package Utils;

my $pkg="Utils";
use Meopta;
use DBI;
my ($user,$pass)=Meopta->sql_user_password;
my $hostname="localhost";

#-- MySQL - znovu nacteni privilegii
sub flush_privileges {
   my $dbh=DBI->connect("DBI:mysql:mysql:$hostname",$user,$pass);
   my $sth=$dbh->prepare("FLUSH PRIVILEGES");
   my $rv=$sth->execute;
   my $rc=$sth->finish;
   my $rc=$dbh->disconnect;
}
#-- citelne zaznamenani hesla pro ucely Maccessu
sub save_password {
   my ($pkg_p,$to_users,$password)=@_;
   my @to_users=split(/,/,$to_users);
   my $dbh=DBI->connect("DBI:mysql:mysql:$hostname",$user,$pass);
   my $sth=$dbh->prepare("replace maccess.Passwd (user,password) values (?,\"$password\")");
   foreach my $to_user (@to_users) {
      my $rv=$sth->execute($to_user);
      my $rc=$sth->finish;
   }
   my $rc=$dbh->disconnect;
}
#-- smazani zaznamu v maccess.Passwd
sub del_password {
   my ($pkg_p,$to_users)=@_;
   my @to_users=split(/,/,$to_users);
   my $dbh=DBI->connect("DBI:mysql:mysql:$hostname",$user,$pass);
   my $sth=$dbh->prepare("delete from maccess.Passwd where user=?");
   foreach my $to_user (@to_users) {
      my $rv=$sth->execute($to_user);
      my $rc=$sth->finish;
   }
   my $rc=$dbh->disconnect;
}
#-- funkce mazajici vsechny zaznamy uzivatelu $to_users v tabulce $tables
sub rights_rm {
   my ($pkg_p,$table,$to_users)=@_;
   my @to_users=split(/,/,$to_users);
   my $dbh=DBI->connect("DBI:mysql:mysql:$hostname",$user,$pass);
   my $query_string="
      delete from
         $table
      where
         User=?
   ";
   my $sth=$dbh->prepare($query_string);
   foreach my $to_user (@to_users) {
      my $rv=$sth->execute($to_user);
      my $rc=$sth->finish;
   }
   my $rc=$dbh->disconnect;
}
#-- funkce kopirujici vsechny zaznamy uzivatele $from_user v tabulce $table do uzivatelu $to_users
sub rights_cp {
   my ($pkg_p,$table,$from_user,$to_users,$password)=@_;
   my @to_users=split(/,/,$to_users);
   my $dbh=DBI->connect("DBI:mysql:mysql:$hostname",$user,$pass);
   my $query_string="
      select
         *
      from
        $table
      where
         User=?
   ";
   my $sth=$dbh->prepare($query_string);
   my $rv=$sth->execute($from_user);
   while(my $ref=$sth->fetchrow_hashref) {
      my @fields=keys %$ref;
      # vyhozneni nekterych polozek u kterych chci, aby se ulozili default hodnoty
      @fields=grep(!/^Timestamp$/,@fields);
      @fields=grep(!/^Grantor$/,@fields);
      my $insert_string="insert into $table (" . join(",",@fields) . ") values (";
      foreach my $field (@fields) {
         if($field=~/^[Uu]ser$/) {
            $insert_string.="?,";
         }
         elsif($field=~/^password$/) {
            $insert_string.="password(\"$password\"),";
         }
         else {
            $insert_string.="\"$$ref{$field}\",";
         }
      }
      chop($insert_string);
      $insert_string.=")";
      my $sth_insert=$dbh->prepare($insert_string);
      foreach my $to_user (@to_users) {
         my $rv_insert=$sth_insert->execute($to_user);
         my $rc_insert=$sth_insert->finish;
      }
   }
   my $rc=$sth->finish;
   my $rc=$dbh->disconnect;
}

return 1;
